diff -Naur --exclude=CVS --exclude=configs linux/hpc/info.c linux-openmosix/hpc/info.c
--- linux/hpc/info.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/info.c	2004-04-06 21:19:38.000000000 +0200
@@ -0,0 +1,980 @@
+/* changes since Feb 12, 2002 by Moshe Bar
+ *
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh, Amnon Barak, Oren Laadan.
+ */
+
+
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <net/sock.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/protocol.h>
+#include <linux/hpc.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+#include <linux/swap.h>
+#include <linux/stddef.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <hpc/hpcversion.h>
+#include <hpc/balance.h>
+
+static int info_seed1, info_seed2;
+
+rwlock_t loadinfo_lock = RW_LOCK_UNLOCKED;
+spinlock_t uplist_lock = SPIN_LOCK_UNLOCKED;
+
+struct uplist {
+	struct uplist *next;
+	unsigned short pe;
+	short age;
+};
+#ifdef CONFIG_MOSIX_LOADLIMIT
+extern unsigned long load_limit;
+extern unsigned long cpu_limit;
+extern unsigned long mosadmin_mode_loadlimit;
+extern unsigned long mosadmin_mode_cpulimit;
+#endif
+
+static struct uplist uplist[MAXKNOWNUP];
+static struct uplist *uphead, *upfree;
+static int info_nup;		/* number of processes in uplist */
+
+struct loadinfo loadinfo[INFO_WIN];
+
+static int info_recv_message(struct infomsg *, int);
+static int info_send_message(int, struct infomsg *);
+static void update_uplist(struct loadinfo *);
+static void update_window(struct loadinfo *);
+static void inform(void);
+static void not_responding(int);
+static void age_uplist(void);
+static int rand(int, int);
+
+static char INFODSTR[] = "oM_infoD";
+
+#define INFO_BUFSIZE	8192
+
+int
+mosix_info_daemon(void *nothing)
+{
+	struct task_struct *p = current;
+	struct loadinfo *load;
+	struct infomsg *msg;
+	static char info_buf[INFO_BUFSIZE]; /* (large) buffer for info load */
+
+	common_daemon_setup(INFODSTR, 1);
+	lock_mosix();
+	info_proc = current;
+	unlock_mosix();
+
+restart:
+	wait_for_mosix_configuration(&info_daemon_active);
+	comm_init_linkpool();
+	if (!p->mosix.contact) {
+		comm_use(p, comm_open(COMM_INFO, 0, 0UL));
+		if (!p->mosix.contact)
+		{
+			printk("%s: failed comm_open - exiting\n", INFODSTR);
+			comm_free_linkpool();
+			if(p->mosix.contact)
+				comm_close(NULL);
+			lock_mosix();
+			info_daemon_active = 0;
+			info_proc = NULL;
+			unlock_mosix();
+			do_exit(0);
+		}
+	}
+
+	msg = (struct infomsg *) info_buf;
+	load = (struct loadinfo *) &msg->load;
+
+	while (1) {
+		comm_wait();
+
+		/* if openMosix was shut down - restart everything */
+                if (!PE) {
+                        comm_close(NULL);
+			comm_free_linkpool();
+                        goto restart;
+                }
+
+		while (info_recv_message(msg, INFO_BUFSIZE))
+		{
+			update_uplist(load);
+			update_window(load);
+			if (!mosadmin_mode_quiet) {
+				load_balance();
+				memory_balance();
+			}
+		}
+
+		if(sigismember(&p->pending.signal, SIGALRM))
+		{
+			spin_lock_irq(&p->sigmask_lock);
+			flush_signals(p);
+			spin_unlock_irq(&p->sigmask_lock);
+
+			if(mosadmin_mode_quiet)
+				continue;
+
+			if(PE)
+				inform();
+			inc_decays();
+			comm_age_linkpool();
+			age_uplist();
+			loadinfo[0].mem = latest_free_mem;
+			loadinfo[0].rmem = nr_free_pages();
+			age_balancing();
+		}
+	}
+}
+
+static void
+age_uplist(void)
+{
+	struct uplist *up, *prev, *cutpoint;
+	int old = 10 * (NPE-1);
+	/* (the more nodes around, the less often they are
+	 * likely to come up again, so we hold them longer) */
+
+	if(old > 32767)
+		old = 32767;
+	spin_lock(&uplist_lock);
+	for (prev = NULL, up = uphead; up; prev = up , up = up->next)
+	if (++up->age >= old)
+	{
+		/* the list is sorted by age, so all the rest are too old! */
+		if (prev)
+			prev->next = NULL;
+		else
+			uphead = NULL;
+		cutpoint = up;
+		while(1)
+		{
+			info_nup--;
+			if(up->next)
+				up = up->next;
+			else
+				break;
+		}
+		prev = upfree;
+		upfree = cutpoint;
+		up->next = prev;
+		break;
+	}
+	spin_unlock(&uplist_lock);
+}
+
+static void
+update_uplist(struct loadinfo *load)
+{
+	struct uplist *up, *prev;
+
+	spin_lock(&uplist_lock);
+	for (prev = NULL , up = uphead ; up ; prev = up , up = up->next)
+	if (up->pe == load->pe)
+	{
+		up->age = 0;
+		if (prev)	/* put it first */
+		{
+			prev->next = up->next;
+			up->next = uphead;
+			uphead = up;
+		}
+		break;
+	}
+	if (!up) {
+		if (upfree) {
+			up = upfree;
+			upfree = upfree->next;
+			info_nup++;
+		} else {
+			for (prev = uphead ; prev->next->next ;
+				prev = prev->next)
+				; /* nothing */
+			up = prev->next;
+			prev->next = NULL;
+		}
+		up->pe = load->pe;
+		up->age = 0;
+		up->next = uphead;
+		uphead = up;
+	}
+	spin_unlock(&uplist_lock);
+        schedule(); /* since a lot of time passed, let's see if there is anything to run in the meantime */
+}
+static void
+update_window(struct loadinfo *load)
+{
+	static int info_slot; /* pointer to next information to fill */
+	unsigned int i;
+
+	info_slot = (info_slot % (INFO_WIN - 1)) + 1;
+	loadinfo[info_slot] = *load;
+
+	for (i = 1 ; i < INFO_WIN ; i++)
+	if (i != info_slot && loadinfo[i].pe == load->pe)
+	{
+		write_lock_bh(&loadinfo_lock);
+		loadinfo[i].pe = 0;
+		write_unlock_bh(&loadinfo_lock);
+		break;
+	}
+
+}
+
+#define	speed_adjust(x)		((x) * ((int64_t)STD_SPD) / loadinfo[0].speed)
+void
+info_update_costs(void)
+{
+	register unsigned int i;
+
+	write_lock_bh(&loadinfo_lock);
+	for(i = 0 ; i < MAX_MOSIX_TOPOLOGY ; i++)
+	{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		loadinfo[0].costs[i].page = mosix_cost[i].PAGE_R;
+		loadinfo[0].costs[i].syscall = mosix_cost[i].SYSCALL_R;
+		loadinfo[0].costs[i].out = mosix_cost[i].COPYOUT_BASE_R;
+		loadinfo[0].costs[i].outkb = mosix_cost[i].COPYOUT_PER_KB_R;
+		loadinfo[0].costs[i].in = mosix_cost[i].COPYIN_BASE_R;
+		loadinfo[0].costs[i].inkb = mosix_cost[i].COPYIN_PER_KB_R;
+		loadinfo[0].costs[i].first = mosix_cost[i].first;
+		loadinfo[0].costs[i].last = mosix_cost[i].last;
+#else
+		remote_here.page = mosix_cost[i].PAGE_R;
+		remote_here.syscall = mosix_cost[i].SYSCALL_R;
+		remote_here.out = mosix_cost[i].COPYOUT_BASE_R;
+		remote_here.outkb = mosix_cost[i].COPYOUT_PER_KB_R;
+		remote_here.in = mosix_cost[i].COPYIN_BASE_R;
+		remote_here.inkb = mosix_cost[i].COPYIN_PER_KB_R;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		remote_here_adjusted[i].page =
+					speed_adjust(mosix_cost[i].PAGE_R);
+		remote_here_adjusted[i].syscall =
+					speed_adjust(mosix_cost[i].SYSCALL_R);
+		remote_here_adjusted[i].out =
+				speed_adjust(mosix_cost[i].COPYOUT_BASE_R);
+		remote_here_adjusted[i].outkb =
+				speed_adjust(mosix_cost[i].COPYOUT_PER_KB_R);
+		remote_here_adjusted[i].in =
+				speed_adjust(mosix_cost[i].COPYIN_BASE_R);
+		remote_here_adjusted[i].inkb =
+				speed_adjust(mosix_cost[i].COPYIN_PER_KB_R);
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		remote_here_adjusted[i].first = mosix_cost[i].first;
+		remote_here_adjusted[i].last = mosix_cost[i].last;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	}
+	write_unlock_bh(&loadinfo_lock);
+}
+
+void
+info_update_mfscosts(void)
+{
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	memcpy(loadinfo[0].mfscosts, mfs_cost, sizeof(mfs_cost));
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+}
+#ifdef CONFIG_MOSIX_LOADLIMIT
+void set_loadlimit(void)
+{
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].load_limit = load_limit;
+	write_unlock_bh(&loadinfo_lock);
+}
+void set_loadlimitmode(void)
+{
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].llimitmode = mosadmin_mode_loadlimit;
+	write_unlock_bh(&loadinfo_lock);
+}
+void set_cpulimitmode(void)
+{
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].cpulimitmode = mosadmin_mode_cpulimit;
+	write_unlock_bh(&loadinfo_lock);
+}
+void set_cpulimit(void)
+{
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].cpu_limit = cpu_limit;
+	write_unlock_bh(&loadinfo_lock);
+}
+
+#endif
+void
+set_my_cpuspeed(void)
+{
+	int s = cpuspeed;
+
+	if(sizeof(loadinfo[0].speed) < 4 && s > 65535)
+	{
+		printk("Computer Too Fast!  Time to Update Standard-Speed.\n");
+		s = 65535;
+	}
+	stable_export = (MF+2) * STD_SPD / (s * smp_num_cpus);
+	if(stable_export == MF * STD_SPD / (s * smp_num_cpus))
+		stable_export++;
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].speed = s;
+	write_unlock_bh(&loadinfo_lock);
+	info_update_costs();
+	info_update_mfscosts();
+}
+
+void
+info_init(void)
+{
+	loadinfo[0].ncpus = smp_num_cpus;
+	loadinfo[0].tmem = num_physpages;
+	set_my_cpuspeed();
+}
+
+void
+info_startup(void)
+{
+	unsigned int i;
+
+	info_seed1 = PE;
+	info_seed2 = PE*PE*PE*PE;
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].pe = PE;
+	for (i = 1 ; i < INFO_WIN ; i++) {
+		loadinfo[i].pe = 0;
+		loadinfo[i].load = 0xffffffff;
+	}
+	write_unlock_bh(&loadinfo_lock);
+
+	spin_lock(&uplist_lock);
+	upfree = uphead = NULL;
+	info_nup = 0;
+
+	memset(uplist, 0, sizeof(struct uplist) * MAXKNOWNUP);
+	for (i = 0; i < MAXKNOWNUP; i++) {
+		uplist[i].next = upfree;
+		upfree = &uplist[i];
+	}
+	spin_unlock(&uplist_lock);
+}
+
+void
+info_reconfig()
+{
+	unsigned int i;
+	struct uplist *up, *prev;
+
+	lock_mosix();	/* because "mos_to_net" does! */
+	spin_lock(&uplist_lock);
+recheck:
+	prev = NULL;
+	for (up = uphead ; up ; prev = up, up = up->next)
+	if (!mos_to_net(up->pe, NULL)) {
+		if (prev)
+			prev->next = up->next;
+		else
+			uphead = up->next;
+		up->next = upfree;
+		upfree = up;
+		info_nup--;
+		goto recheck;
+	}
+	spin_unlock(&uplist_lock);
+	write_lock_bh(&loadinfo_lock);
+	for (i = 1; i < INFO_WIN; i++)
+		if (loadinfo[i].pe && !mos_to_net(loadinfo[i].pe, NULL))
+			loadinfo[i].pe = 0;
+	write_unlock_bh(&loadinfo_lock);
+	unlock_mosix();
+}
+
+static int
+info_recv_message(struct infomsg *info, int bufsize)
+{
+	static mosix_addr ra;		/* reply address */
+	struct mosix_link *l = current->mosix.contact;
+	struct loadinfo *load = &(info->load);
+	int n;
+	int sender;
+
+	while (1) {
+		n = comm_recvfrom(info, bufsize, l, &ra, 0);
+
+		if (n == -EDIST)
+			continue;	/* message > bufsize */
+
+		if (n < 0)
+			return (0);
+
+		if (n < sizeof(*info)) {
+			continue;
+		}
+
+		if (info->version != MOSIX_BALANCE_VERSION) {
+			continue;
+		}
+		if (info->topology != MAX_MOSIX_TOPOLOGY) {
+			continue;
+		}
+
+		sender = load->pe ? : load->speed;
+		if (sender > MAXPE || sender != net_to_mos(&ra)) {
+			continue;
+		}
+
+		if (sender == PE)
+		{
+			printk("WARNING: Another computer is masquerading as same openMosix node as this (%d)!\n", PE);
+			continue;
+		}
+	
+
+		if (load->pe)
+			return (1);
+
+		/*
+		 * Ugly convention: !load->pe ==> this is a GETLOAD request
+		 */
+
+		lock_mosix();
+		write_lock_bh(&loadinfo_lock);
+		loadinfo[0].status = my_mosix_status();
+		loadinfo[0].free_slots = get_free_guest_slots();
+		unlock_mosix();
+		loadinfo[0].mem = latest_free_mem;
+		loadinfo[0].rmem = nr_free_pages();
+		loadinfo[0].util = acpuse;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		loadinfo[0].load_limit = load_limit;
+		loadinfo[0].cpu_limit = cpu_limit;
+		loadinfo[0].llimitmode = mosadmin_mode_loadlimit;
+		loadinfo[0].cpulimitmode = mosadmin_mode_cpulimit;
+#endif
+#ifdef CONFIG_MOSIX_RESEARCH
+		loadinfo[0].rio = io_read_rate;
+ 		loadinfo[0].wio = io_write_rate;
+#endif /* CONFIG_MOSIX_RESEARCH */
+		*load = loadinfo[0];
+		write_unlock_bh(&loadinfo_lock);
+
+		
+		comm_sendto(COMM_TOADDR, info, sizeof(*info), l, &ra);
+	}
+	return(0);
+}
+
+static int
+info_send_message(int mos, struct infomsg *info)
+{
+
+	return(comm_sendto(mos, info, sizeof(*info), current->mosix.contact,
+								NULL) < 0);
+}
+
+int
+load_to_mosix_info(struct loadinfo l, struct mosix_info *info, int touser)
+{
+	struct mosix_info tmp, *uaddr;
+	int error;
+
+	if(touser)
+	{
+		uaddr = info;
+		info = &tmp;
+	}
+	else
+		uaddr = NULL;	/* pacify angry stupid gcc */
+	info->load = ((int64_t)l.load) * standard_speed / STD_SPD;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	info->load_limit = l.load_limit;
+	info->llimitmode = l.llimitmode;
+	info->loadlocal = l.loadlocal;
+	info->loadremote = l.loadremote;
+	info->cpulimitmode = l.cpulimitmode;
+	info->cpu_limit = l.cpu_limit;
+	info->cpulocal = l.cpulocal;
+	info->cpuremote = l.cpuremote;
+#endif
+	info->speed = l.speed;
+	info->ncpus = l.ncpus;
+	info->mem = (s64) l.mem * PAGE_SIZE;
+	info->rmem = (s64) l.rmem * PAGE_SIZE;
+	info->tmem = (s64) l.tmem * PAGE_SIZE;
+	info->util = l.util;
+
+	info->status = l.status;
+	if(touser && (error = copy_to_user((char *)uaddr, (char *)info,
+								sizeof(*info))))
+		return(-EFAULT);
+	return(0);
+}
+
+static int info_serialno = 0;
+static int info_timo;
+static int info_retry;
+static int info_retry_cnt;
+
+#define	INFO_TIMO 50000		/* ms */
+#define	INFO_RETRY 20000	/* after 20 & 40 ms */
+
+#define	SIMULTANEOUS_QUERIES		10
+
+void
+mosinfo_update_gateways(void)
+{
+	/* the following may be further optimized in the future: */
+	info_timo = INFO_TIMO * (mosadmin_gateways + 1);
+#if INFO_RETRY * 3 > 65535
+#error: "timtosend" below must be made "unsigned int".
+#endif
+	info_retry = INFO_RETRY * (mosadmin_gateways + 1);
+	info_retry_cnt = (info_timo + info_retry - 1) / info_retry;
+}
+
+int
+balance_get_infos(int first, int num, struct mosix_info *info, int touser)
+{
+	char *donebits, fewbits[20]; /* 20*8=160 seems to cover most cases */
+	struct progress
+	{
+		unsigned short node;
+		unsigned short timtosend;
+		unsigned int timo;
+		int serialno;
+	} progress[SIMULTANEOUS_QUERIES];
+	unsigned int hint = 0;
+	unsigned int ntaken = 0;
+	unsigned int ndone = 0;
+	unsigned int inpot = 0;
+	int node, from, n;
+	unsigned int i;
+	int error = 0;
+	int timo;
+	now_t before;
+	mosix_link *mlink;
+	struct loadinfo l;
+	struct infomsg infomsg;
+
+	if(num <= 8*sizeof(fewbits))
+		donebits = fewbits;
+	else if(!(donebits = (char *)kmalloc((num+7)/8, GFP_KERNEL)))
+		return(-ENOMEM);
+	memset(donebits, 0, (num+7)/8);
+	if (!(mlink = comm_borrow_linkpool()))
+		error = -EDIST;
+	loop:
+	while(!error && ndone < num)
+	{
+		while(inpot < SIMULTANEOUS_QUERIES && ntaken < num)
+		{
+			while(donebits[hint/8] & (1 << (hint%8)))
+			if(++hint == num)
+				hint = 0;
+			donebits[hint/8] |= (1 << (hint%8));
+			ntaken++;
+			node = first + hint;
+			if (node == PE)
+			{
+				read_lock_bh(&loadinfo_lock);
+				l = loadinfo[0];
+				read_unlock_bh(&loadinfo_lock);
+				l.status = my_mosix_status();
+#ifdef CONFIG_MOSIX_LOADLIMIT
+				l.load_limit = load_limit;
+				l.llimitmode = mosadmin_mode_loadlimit;
+				l.cpulimitmode = mosadmin_mode_cpulimit; 
+				l.cpu_limit = cpu_limit;
+#endif
+				l.util = acpuse;
+#ifdef CONFIG_MOSIX_RESEARCH 
+				l.rio = io_read_rate;
+				l.wio = io_write_rate;
+#endif /* CONFIG_MOSIX_RESEARCH  */
+				ready_immediate:
+				ndone++;
+				if((error = load_to_mosix_info(l, &info[hint],
+								touser)))
+					break;
+				continue;
+			}
+			if (!mos_to_net(node, NULL))
+			{
+				l.status = 0;
+				goto ready_immediate;
+			}
+			progress[inpot].node = node;
+			progress[inpot].timo = info_timo;
+			progress[inpot].timtosend = 0;
+			progress[inpot].serialno = info_serialno++;
+			inpot++;
+		}
+		if(error || ndone == num)
+			break;
+		timo = info_retry;
+		for(i = 0 ; i < inpot ; i++)
+		{
+			if(progress[i].timo < timo)
+				timo = progress[i].timo;
+			if(progress[i].timo && progress[i].timtosend <= 0)
+			{
+				progress[i].timtosend = info_retry;
+				infomsg.version = MOSIX_BALANCE_VERSION;
+				infomsg.serialno = progress[i].serialno;
+				infomsg.topology = MAX_MOSIX_TOPOLOGY;
+				infomsg.load.pe = 0;	/* eg. GETLOAD */
+				infomsg.load.speed = PE;
+				if(comm_sendto(progress[i].node, &infomsg,
+					sizeof(infomsg), mlink, NULL) <= 0)
+				{
+					node = progress[i].node;
+					progress[i] = progress[--inpot];
+					ndone++;
+					l.status = DS_MOSIX_DEF;
+					error = load_to_mosix_info(l,
+						&info[node - first], touser);
+					goto loop;
+				}
+			}
+			if(progress[i].timtosend < timo)
+				timo = progress[i].timtosend;
+		}
+		before = time_now();
+		n = comm_recvfrompe(&infomsg, sizeof(infomsg), mlink, &from,
+								info_retry);
+		if (n == sizeof(infomsg))
+		for (i = 0; i < inpot; i++) {
+			if (from == progress[i].node &&
+			    infomsg.load.pe == progress[i].node &&
+			    infomsg.serialno == progress[i].serialno) {
+			    	ndone++;
+				node = progress[i].node;
+				progress[i] = progress[--inpot];
+				error = load_to_mosix_info(infomsg.load,
+						&info[node - first], touser);
+				break;
+			}
+		} else if (signal_pending(current))
+			error = -EINTR;
+		if (error)
+			break;
+
+		before = time_since(before);
+		if(before > timo)
+			before = timo;
+		if(before)
+		for(i = 0 ; i < inpot ; i++)
+		{
+			progress[i].timo -= before;
+			if(progress[i].timtosend < before)
+				progress[i].timtosend = 0;
+			else
+				progress[i].timtosend -= before;
+		}
+		if(n <= 0)
+		for(i = 0 ; i < inpot ; i++)
+		if(progress[i].timo <= 0)	/* cannot realy be < */
+		{
+			node = progress[i].node;
+			progress[i] = progress[--inpot];
+			ndone++;
+			l.status = DS_MOSIX_DEF;
+			if((error = load_to_mosix_info(l,
+				&info[node - first], touser)))
+				break;
+			i--;
+		}
+	}
+	if (mlink)
+		comm_return_linkpool(mlink);
+	if(num > 8*sizeof(fewbits))
+		kfree(donebits);
+	return(error);
+}
+int
+balance_ask_node(int node, struct infomsg *info)
+{
+	mosix_link *mlink = NULL;
+	int from, n, error = 0;
+	int serialno;
+	int tries;
+	now_t before;
+	int timo;
+
+	if (!(mlink = comm_borrow_linkpool()))
+		error = -EDIST;
+	serialno = info_serialno++;
+	tries = info_retry_cnt;
+	timo = info_retry;
+	while (!error && tries--) {
+		info->version = MOSIX_BALANCE_VERSION;
+		info->serialno = serialno;
+		info->topology = MAX_MOSIX_TOPOLOGY;
+		info->load.pe = 0;	/* eg. GETLOAD */
+		info->load.speed = PE;
+		error = comm_sendto(node, info, sizeof(*info), mlink, NULL);
+		if (error < sizeof(*info))
+		{
+			if(error >= 0)
+				error = -EDIST;
+			goto out;
+		}
+		error = 0;
+		before = time_now();
+		n = comm_recvfrompe(info, sizeof(*info), mlink, &from, timo);
+		if (n == sizeof(*info) && from == node &&
+			info->load.pe == node && info->serialno == serialno)
+			goto out;
+		before = time_since(before);
+		if(before < timo)
+		{
+			timo -= before;
+			tries++;
+		}
+		else
+			timo = info_retry;
+	}
+	error = -EAGAIN;
+out:
+	if (mlink)
+		comm_return_linkpool(mlink);
+	return (error);
+}
+
+int
+balance_get_info(int node, struct mosix_info *info)
+{
+	struct infomsg infomsg;
+	int error;
+
+	if (node == PE || node == 0) 		/* local info */
+	{
+		read_lock_bh(&loadinfo_lock);
+		infomsg.load = loadinfo[0];
+		read_unlock_bh(&loadinfo_lock);
+		infomsg.load.status = my_mosix_status();
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		infomsg.load.load_limit = load_limit;
+		infomsg.load.llimitmode = mosadmin_mode_loadlimit; 
+		infomsg.load.cpulimitmode = mosadmin_mode_cpulimit;
+		infomsg.load.cpu_limit = cpu_limit;
+#endif
+		infomsg.load.util = acpuse;
+#ifdef CONFIG_MOSIX_RESEARCH
+		infomsg.load.rio  = io_read_rate;
+ 		infomsg.load.wio  = io_write_rate;
+#endif /* CONFIG_MOSIX_RESEARCH */
+
+		load_to_mosix_info(infomsg.load, info, 0);
+	}
+	else if (!mos_to_net(node, NULL))
+		info->status = 0;
+	else if((error = balance_ask_node(node, &infomsg)))
+	{
+		info->status = DS_MOSIX_DEF;
+		return(error);
+	}
+	else
+		load_to_mosix_info(infomsg.load, info, 0);
+	return(0);
+}
+
+int
+balance_get_load(int node, struct loadinfo *l)
+{
+	struct infomsg infomsg;
+
+	if (node == PE || node == 0)
+	{
+		*l = loadinfo[0];
+		return(0);
+	}
+	else if (!mos_to_net(node, NULL))
+		return(-1);
+	else if(balance_ask_node(node, &infomsg))
+		return(-1);
+	*l = infomsg.load;
+	return(0);
+}
+
+static void
+inform()
+{
+	int to;
+	int i;
+	struct uplist *up;
+	struct infomsg info;
+
+	info.version = MOSIX_BALANCE_VERSION;
+	info.topology = MAX_MOSIX_TOPOLOGY;
+	info.serialno = 0;		/* meaning no serial number */
+	write_lock_bh(&loadinfo_lock);
+	loadinfo[0].free_slots = get_free_guest_slots();
+	info.load = loadinfo[0];
+	write_unlock_bh(&loadinfo_lock);
+	info.load.load = export_load;
+
+	/* first select any node, and send the load */
+	lock_mosix();
+	to = (NPE > 1) ? nth_node(rand(NPE-1, 1)) : 0;
+	unlock_mosix();
+	if(to && info_send_message(to, &info))
+		not_responding(to);
+
+	/* then select a node that seems to be up */
+	spin_lock(&uplist_lock);
+	if (info_nup)
+	{
+		for (up = uphead , i = rand(info_nup, 0) ; i-- ; up = up->next)
+			; /* just stop at random element */
+		to = (up->pe == to) ? 0 : up->pe;
+	}
+	else
+		to = 0;
+	spin_unlock(&uplist_lock);
+	if (to && info_send_message(to, &info))
+		not_responding(to);
+}
+
+void
+not_responding(int pe)
+{
+	unsigned int i;
+	struct uplist *up, *prev;
+
+	spin_lock(&uplist_lock);
+	prev = NULL;
+	for (up = uphead ; up ; prev = up , up = up->next)
+	if (up->pe == pe)
+	{
+		if (prev)
+			prev->next = up->next;
+		else
+			uphead = up->next;
+		up->next = upfree;
+		upfree = up;
+		info_nup--;
+		break;
+	}
+	spin_unlock(&uplist_lock);
+	write_lock_bh(&loadinfo_lock);
+	for (i = 1; i < INFO_WIN; i++)
+	if (loadinfo[i].pe == pe)
+		loadinfo[i].pe = 0;
+	write_unlock_bh(&loadinfo_lock);
+}
+
+void
+this_machine_is_favourite(int which)
+{
+	register struct uplist *up;
+
+	spin_lock(&uplist_lock);
+	for(up = uphead ; up ; up = up->next)
+		if(up->pe == which)
+			break;
+	if(!up && upfree)
+#ifdef CONFIG_MOSIX_CHEAT_MIGSELF
+	if(which != PE)
+#endif /* CONFIG_MOSIX_CHEAT_MIGSELF */
+	{
+		up = upfree;
+		upfree = upfree->next;
+		up->next = uphead;
+		up->pe = which;
+		up->age = 0;
+		uphead = up;
+		info_nup++;
+	}
+	spin_unlock(&uplist_lock);
+}
+
+static int
+rand(int modulo, int regen)
+{
+	if(regen)
+	{
+		info_seed2++;
+		/* alternating even/odd values: */
+		info_seed1 = info_seed1*info_seed2 + 1;
+		return((info_seed1 & 0x7fffffff) % modulo);
+	}
+	else
+		return((((info_seed2+1)*info_seed1+1) & 0x7fffffff) % modulo);
+}
+
+/*
+ * we are 99.99% going to migrate and let other processes be migrated,
+ * but not before we adjust the local and remote loads to discourage
+ * further migrations.
+ */
+void
+release_migrations(int whereto)
+{
+	register struct mosix_task *m = &current->mosix;
+	register int load;
+	unsigned int i;
+	int pages = m->migpages ? : count_migrating_pages();
+
+	this_machine_is_favourite(whereto);
+
+	/* Decrease the local load by the load caused by this process,
+	 * to avoid over-migration.
+	 */
+	write_lock_bh(&loadinfo_lock);
+	spin_lock_irq(&runqueue_lock);
+	load = m->load * STD_SPD / 4 / cpuspeed;
+	load /= smp_num_cpus;
+	  /* It is ON PURPOSE that `acpuse' is not taken into account */
+	if(loadinfo[0].load < load)   /* should not happen, but ... */
+		load = loadinfo[0].load;
+	load_left += load;
+	spin_unlock_irq(&runqueue_lock);
+
+	loadinfo[0].load -= load;
+
+	/* increase the receiver's-load */
+	for(i = 1 ; i < INFO_WIN ; i++)
+	if(loadinfo[i].pe == whereto)
+	{
+		/* add slightly more than 1 process worth of load */
+		loadinfo[i].load += MF * 102 * STD_SPD/
+			(loadinfo[i].speed * loadinfo[i].ncpus * 100);
+		loadinfo[i].mem -= pages;
+		break;
+	}
+	write_unlock_bh(&loadinfo_lock);
+	m->pages_i_bring = -pages; /* discourage 'memory_badly_required' */
+	unchoose_me();
+}
+
+void
+info_someone_came_in(void)
+{
+	write_lock_bh(&loadinfo_lock);
+	coming_in++;
+	came_lately4 += 4;
+	export_load += MF * STD_SPD / (smp_num_cpus * cpuspeed);
+	write_unlock_bh(&loadinfo_lock);
+}
+
+void
+end_coming_in(int error)
+{
+	write_lock_bh(&loadinfo_lock);
+	coming_in--;
+	if(error)
+	{
+		if((int)(came_lately4 -= 4) < 0)
+			came_lately4 = 0;
+	}
+	write_unlock_bh(&loadinfo_lock);
+}
diff -Naur --exclude=CVS --exclude=configs linux/hpc/init.c linux-openmosix/hpc/init.c
--- linux/hpc/init.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/init.c	2002-11-24 21:45:57.000000000 +0100
@@ -0,0 +1,52 @@
+/* All changes since Feb 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+#include <linux/sched.h>
+#include <linux/delay.h>
+#include <linux/mm.h>
+#include <linux/smp_lock.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/hpcversion.h>
+#include <hpc/balance.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define	STD_LOOPS	9961472  /* loops per jiffy on standard processor */
+
+void
+init_mosix(void)
+{
+	extern int x86_udelay_tsc;
+	cpuspeed = ((int64_t)loops_per_jiffy) * STD_SPD / STD_LOOPS;
+	if(!x86_udelay_tsc)
+		cpuspeed *= 2;
+	info_init();
+	proc_update_costs();
+#ifdef CONFIG_MOSIX_FS
+	init_mfs();
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_init();
+#endif /* CONFIG_MOSIX_DFSA */
+	kernel_thread(mosix_mig_daemon, NULL, 0);
+	info_startup();
+	mosix_load_init();
+	mosinfo_update_gateways();
+	kernel_thread(mosix_info_daemon, NULL, 0);
+	kernel_thread(mosix_mem_daemon, NULL, 0);
+}
